/*******************************************************************************
*  LogWriter.h - Write logs for berzerk
*
*  Berzerk/
*
*  Part of the BuckoSoft Network Monitor
*  Copyright(c) 2009 - BuckoSoft, Inc.
*
*  http://git.buckosoft.com/gitweb/?p=Berzerk.git;a=history;f=Berzerk/LogWriter.h
*
\*******************************************************************************/

#ifndef	_LOGWRITER_H_
#define	_LOGWRITER_H_

#include <string>
#include <list>
using namespace std;

class Berzerk;

class LogWriter {
  public:
	LogWriter();
	//void	setFileName(const string& outputLogFileName);
	void	setLogFmt(const string& fmt);

	void	setLogLevel(int logLevel);
	int		getLogLevel();

	void	log(int level, const string& logLine);
	void	log(int level, const char* logLine);

	void			setBerzerk(Berzerk* berzerk);
	static void		setDEBUG(int value);

  protected:
	string	getTimestamp();

  private:
	int				logLevel;
	string			logFmt;
	Berzerk*		berzerk;
	string			logFileName;

	static int		DEBUG;
};

inline void LogWriter::setBerzerk(Berzerk* bz) { berzerk = bz; };
inline void LogWriter::setDEBUG(int level) { DEBUG = level; }

inline void LogWriter::setLogLevel(int l) { logLevel = l; }
inline int  LogWriter::getLogLevel() { return(logLevel); }

inline void LogWriter::log(int level, const string& logLine) { this->log(level, logLine.c_str()); }
inline void LogWriter::setLogFmt(const string& fmt) { this->logFmt = fmt; }
#endif		// _LOGWRITER_H_
